# -*- encoding: utf-8 -*-
##
##
## Copyright (C) 2011 Thibaut Girka <thib@sitedethib.com>
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 3 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##


class BulletType(object):
    def __init__(self, texcoords, blend_mode, automatic_rotation, hitbox):
        self.texcoords = texcoords
        self.hitbox = hitbox
        self.blend_mode = blend_mode
        self.automatic_rotation = automatic_rotation


default_bullet_types = [
                    # Boss bullets
                    [BulletType((0, 0, 16, 16), 0, False, (-2, -2, 2, 2)),
                     BulletType((16, 0, 16, 16), 0, False, (-2, -2, 2, 2)),
                     BulletType((32, 0, 16, 16), 0, False, (-2, -2, 2, 2)),
                     BulletType((48, 0, 16, 16), 0, False, (-2, -2, 2, 2)),
                     BulletType((64, 0, 16, 16), 0, False, (-2, -2, 2, 2)),
                     BulletType((80, 0, 16, 16), 0, False, (-2, -2, 2, 2)),
                     BulletType((96, 0, 16, 16), 0, False, (-2, -2, 2, 2)),
                     BulletType((112, 0, 16, 16), 0, False, (-2, -2, 2, 2)),

                     BulletType((0, 16, 16, 24), 0, True, (-2, -2, 2, 2)),
                     BulletType((16, 16, 16, 24), 0, True, (-2, -2, 2, 2)),
                     BulletType((32, 16, 16, 24), 0, True, (-2, -2, 2, 2)),
                     BulletType((48, 16, 16, 24), 0, True, (-2, -2, 2, 2)),
                     BulletType((64, 16, 16, 24), 0, True, (-2, -2, 2, 2)),
                     BulletType((80, 16, 16, 24), 0, True, (-2, -2, 2, 2)),
                     BulletType((96, 16, 16, 24), 0, True, (-2, -2, 2, 2)),
                     BulletType((112, 16, 16, 24), 0, True, (-2, -2, 2, 2)),

                     BulletType((0, 40, 24, 24), 1, False, (-4, -4, 4, 4)),
                     BulletType((24, 40, 24, 24), 1, False, (-4, -4, 4, 4)),
                     BulletType((48, 40, 24, 24), 1, False, (-4, -4, 4, 4)),
                     BulletType((72, 40, 24, 24), 1, False, (-4, -4, 4, 4)),
                     BulletType((96, 40, 24, 24), 1, False, (-4, -4, 4, 4))],

                    # Drone bullets
                    [BulletType((0, 64, 8, 12), 0, True, (-1, -1, 1, 1)),
                     BulletType((8, 64, 8, 12), 0, True, (-1, -1, 1, 1)),
                     BulletType((16, 64, 8, 12), 0, True, (-1, -1, 1, 1)),
                     BulletType((24, 64, 8, 12), 0, True, (-1, -1, 1, 1)),
                     BulletType((32, 64, 8, 12), 0, True, (-1, -1, 1, 1)),
                     BulletType((40, 64, 8, 12), 0, True, (-1, -1, 1, 1)),
                     BulletType((48, 64, 8, 12), 0, True, (-1, -1, 1, 1))],

                    #
                    [BulletType((2, 255-22, 12, 22), 0, False, (-2, -2, 2, 2))]
               ]
